#include "standardModelHeaders.h"


using namespace std;
using namespace tohoku;
using namespace OpenHRP;


StandardModel::StandardModel()
{
  virtualJoints.clear();
  parts.clear();

  nameToVirtualJointMap.clear();
  nameToPartMap.clear();
}


StandardModel::~StandardModel()
{
  virtualJoints.clear();
  parts.clear();

  nameToVirtualJointMap.clear();
  nameToPartMap.clear();
}


void StandardModel::addPart(StandardModelPart* part)
{
  parts.push_back(part);

  nameToPartMap[part->name] = part;
}


void StandardModel::updateStandardModel()
{
  virtualJoints.clear();
  nameToVirtualJointMap.clear();

  for(unsigned int i = 0; i < parts.size(); i++) {
    for(int j = 0; j < parts[i]->numVirtualJoints(); j++) {
      virtualJoints.push_back(parts[i]->virtualJoint(j));

      nameToVirtualJointMap[parts[i]->virtualJoint(j)->name] = parts[i]->virtualJoint(j);
    }
  }
}


VirtualJoint* StandardModel::virtualJoint(const std::string& name) const
{
  NameToVirtualJointMap::const_iterator p = nameToVirtualJointMap.find(name);
  return (p != nameToVirtualJointMap.end()) ? p->second : 0;
}


StandardModelPart* StandardModel::part(const std::string& name) const
{
  NameToPartMap::const_iterator p = nameToPartMap.find(name);
  return (p != nameToPartMap.end()) ? p->second : 0;
}
